VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Sample program for M-CAN-1"
   ClientHeight    =   6795
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9315
   LinkTopic       =   "Form1"
   ScaleHeight     =   6795
   ScaleWidth      =   9315
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Dout0 
      Caption         =   "DOUT 0"
      Enabled         =   0   'False
      Height          =   615
      Left            =   1920
      TabIndex        =   4
      Top             =   240
      Width           =   855
   End
   Begin VB.ComboBox CanActions 
      Enabled         =   0   'False
      Height          =   315
      ItemData        =   "M049smpl.frx":0000
      Left            =   360
      List            =   "M049smpl.frx":0016
      TabIndex        =   3
      Text            =   "Can Actions"
      Top             =   1080
      Width           =   2415
   End
   Begin VB.TextBox Text2 
      Height          =   6015
      Left            =   3600
      MultiLine       =   -1  'True
      TabIndex        =   2
      Text            =   "M049smpl.frx":00FB
      Top             =   120
      Width           =   5175
   End
   Begin VB.TextBox Text1 
      Enabled         =   0   'False
      Height          =   2175
      Left            =   360
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "M049smpl.frx":010C
      Top             =   3960
      Width           =   2415
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   615
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub CanActions_Click()
   Dim WhatToDo
   Dim State As Byte
   Dim count As Long
   Dim textmsg As String
   Dim error As Integer
    
   WhatToDo = CanActions.ListIndex
   Select Case WhatToDo
   Case 0
        State = m049_get_dout(micro_slot, 0)
        error = m049_set_data(micro_slot, ActSndObjDout0, State, 1)
        If (display_error(error, "m049_set_data ActSndObjDout0") <> 0) Then
            Exit Sub
        End If
        error = m049_send_data(micro_slot, ActSndObjDout0)
        If (display_error(error, "m049_send_data ActSndObjDout0") <> 0) Then
            Exit Sub
        End If
    Case 1
        error = m049_send_data_request(micro_slot, ActRcvObj1)
        If (display_error(error, "m049_send_data_request ActRcvObj1") <> 0) Then
           Exit Sub
        End If
    Case 2
        error = m049_send_data_request(micro_slot, ActRcvObjGetID)
        If (display_error(error, "m049_send_data_request ActRcvObjGetID") <> 0) Then
           Exit Sub
        End If
    Case 3
        id = &H37
        control_flags = M049_PASSIVE  ' passive receive object
        serv_task = tasknum
        serv_func = M049_SRQ_SERVICE_FUNC
        error = m049_create_msg_object(micro_slot, PasRcvObj2, id, _
                control_flags, serv_task, serv_func)
        If (display_error(error, "m049_config_msg_object") <> 0) Then
           Exit Sub
        End If
    Case 4
        count = &HFFC   ' acceptance mask
        error = m049_set_acceptance_mask(micro_slot, count, 0, _
                                         tasknum, M049_SRQ_SERVICE_FUNC)
        If (display_error(error, "m049_set_acceptance_mask") <> 0) Then
           Exit Sub
        End If
        textmsg = "Acceptance Mask is " & format(Hex(count), "0000")
        MsgBox (textmsg)
    Case 5
        error = m049_get_msg_count(micro_slot, PasSndObjCount, count)
        If (display_error(error, "m049_get_msg_count PasSndObjCount") <> 0) Then
           Exit Sub
        End If
        textmsg = "Message Object with ID 27h has received " & format(Hex(count), "0000") & " messages"
        MsgBox (textmsg)
    End Select
        
End Sub

Private Sub Dout0_Click()
    If StateOfDout0 = 1 Then
        StateOfDout0 = 0
    Else
        StateOfDout0 = 1
    End If
    Call m049_set_dout(micro_slot, 0, StateOfDout0)
End Sub


Private Sub Command1_Click()
   
   Dim errormsg As String
   Dim error As Integer
   Dim count(4) As Byte
   Dim versionstr As String * 80
   Dim datestr As String * 80
   Dim version As Long
   Dim datum As Long
   Dim irq As Integer
   Dim config As M049ConfigType
         
   ' Initialization of global variables
   micro_slot = 2
   StateOfDout0 = 1
   tasknum = micro_slot
   ServTaskNum = &H23
   
   ml8_bib_startup (LANGUAGE_C) ' library initialization
   
   irq = &H7C           ' interrupt used by the M-CAN-1
   error = ml8_reset(0, &H380, 0, 7, 3, AddressOf error_handler, "ROM", 20)
'  error = ml8_start(0, &H380, 0, 7, 3, AddressOf error_handler, 10)
   If error <> 0 Then
      errormsg = "Error " & format(Hex(error), "0000") & "h in ml8_reset"
      error = MsgBox(errormsg, vbOKOnly, "Error message")
      ml8_exit
      Exit Sub
   End If
   
   error = ml8_transfer_and_install("..\..\..\..\m049task\m049task.exe", _
           0, tasknum, M049TASK_PROG_NO, irq, M049TASK_FLAGS, 0)
   If error <> 0 Then
      errormsg = "Error " & format(Hex(error), "0000") & " in transfer of m049task"
      error = MsgBox(errormsg, vbOKOnly, "Error message")
      ml8_exit
      Exit Sub
   End If

   Call ml8_set_service(AddressOf msg_service)
   
   error = m049_bib_startup
   If error <> 0 Then
      errormsg = "Error " & format(Hex(error), "0000") & " in m049_bib_startup"
      error = MsgBox(errormsg, vbOKOnly, "Error message")
      ml8_exit
      Exit Sub
   End If

   ' install program m8p0412 as a message service task
   error = ml8_transfer_and_install("..\..\..\rt\pascal\sample\m8p0412.exe", _
                     0, ServTaskNum, &H412, 0, &H983, 0)
   If (error <> 0) Then
      errormsg = "Error " & format(Hex(error), "0000") & " in transfer of m8p0412"
      error = MsgBox(errormsg, vbOKOnly, "Error message")
      ml8_exit
      Exit Sub
   End If
   Call ml8_write_par_byte(ServTaskNum, 0, micro_slot) ' init m8p0412 micro slot
   error = ml8_read_par_word(ServTaskNum, 1)     ' check m8p0412 error status
   If (error <> 0) Then
      errormsg = "Error " & format(Hex(error), "0000") & " in auto init of m8p0412"
      error = MsgBox(errormsg, vbOKOnly, "Error message")
      ml8_exit
      Exit Sub
   End If
   
   config.serv_task = tasknum
   config.serv_func = M049_SRQ_SERVICE_FUNC
   config.messages = 0 ' not used by m049task if version >= 2.A
   error = m049_config_module(micro_slot, config)
   If (display_error(error, "m049_config_module") <> 0) Then
      Exit Sub
   End If
   error = msg_configuration
   If error <> 0 Then
      Exit Sub
   End If
   error = m049_start_com(micro_slot)
   If (display_error(error, "m049_start_com") <> 0) Then
      Exit Sub
   End If

   ' get version info
   Call ml8_get_osx_version(version, datum)
   Call ml8_create_version_string(versionstr, version)
   Call ml8_create_date_string(datestr, datum)
   Text1.text = Text1.text & vbCrLf & _
                "OsX " & versionstr & datestr
   Call ml8_get_lib_version(version, datum)
   Call ml8_create_version_string(versionstr, version)
   Call ml8_create_date_string(datestr, datum)
   Text1.text = Text1.text & vbCrLf & _
                "Library " & versionstr & " " & datestr
   Call ml8_get_mlxdrv_version(version, datum)
   Call ml8_create_version_string(versionstr, version)
   Call ml8_create_date_string(datestr, datum)
   Text1.text = Text1.text & vbCrLf & _
                "MLXDRV.SYS " & versionstr & " " & datestr
   Call ml8_get_task_info(tasknum, 4, datum)
   datum = datum And &HFFFF0000
   datum = datum / &H10000
   version = datum / &H100 ' program revision
   datum = datum And &HFF  ' program version
   Text1.text = Text1.text & vbCrLf & "M049Task " & Chr(datum) & "." & Chr(version) & _
               " installed as task no " & format(Hex(tasknum), "0000")
   Text1.text = Text1.text & vbCrLf & _
                "M-CAN-1-Settings: Slot: " & format(Hex(micro_slot), "0") & _
                " Interrupt: " & format(Hex(irq), "00")

   ' initialize data of PasSndObjCount
   count(0) = 0
   count(1) = 0
   count(2) = 0
   count(3) = 0
   error = m049_set_data(micro_slot, PasSndObjCount, count(0), 4)
   If (display_error(error, "m049_set_data PasSndObjCount") <> 0) Then
      Exit Sub
   End If
   
   Dout0.Enabled = True
   CanActions.Enabled = True

   ' enable interrupt locking
   Call m049_enable_int_mask(micro_slot)
End Sub

